/**
 * Translator Revolution WP Plugin
 * http://www.20script.ir
 *
 * LICENSE
 *
 * You need to buy a license if you want use this script.
 * http://codecanyon.net/legal/market
 *
 * @package    Translator Revolution WP Plugin
 * @copyright  Copyright (c) 2015, SurStudio, www.surstudio.net
 * @license    http://codecanyon.net/licenses/standard
 * @version    1.8
 * @date       2015-02-02
 */

var SurStudioPluginTranslatorRevolutionLiteAdmin = {

	_tabs: {
		general: null,
		advanced: null,
		translations: null,
		support: null
	},
	
	_form: null,
	_action: null,
	_buttons: {},
	
	_headings: {},
	_ajax_url: null,
	
	_fields: {
		general: {},
		advanced: {},
		translations: {}
	},
	
	_xhr: {
		resource: null,
		languages: null,
		translations: null
	},

	initialize: function(_ajax_url) {
		
		SurStudioPluginTranslatorRevolutionLiteAdmin._set_ajax_url(_ajax_url);
		
		SurStudioPluginTranslatorRevolutionLiteAdmin._initialize_elements();
		SurStudioPluginTranslatorRevolutionLiteAdmin._initialize_events();
		SurStudioPluginTranslatorRevolutionLiteAdmin._initialize_tooltips();
		SurStudioPluginTranslatorRevolutionLiteAdmin._initialize_headings();
		SurStudioPluginTranslatorRevolutionLiteAdmin._initialize_languages();
		SurStudioPluginTranslatorRevolutionLiteAdmin._initialize_tabs();

		SurStudioPluginTranslatorRevolutionLiteAdmin._initialize_dependences();
		
	}, 
	
	_get_ajax_url: function() {
		
		return this._ajax_url;
		
	},
	
	_set_ajax_url: function(_ajax_url) {
		
		this._ajax_url = _ajax_url;
		
	},
	
	_initialize_tabs: function() {
		
		this._tabs.general = new SurStudioPluginTranslatorRevolutionLiteCommon.Tabs();

		this._tabs.general.registerTab("general", SurStudioPluginTranslatorRevolutionLiteAdmin._show_buttons_on_tab);
		this._tabs.general.registerTab("advanced", SurStudioPluginTranslatorRevolutionLiteAdmin._show_buttons_on_tab);
		this._tabs.general.registerTab("translations", SurStudioPluginTranslatorRevolutionLiteAdmin._show_buttons_on_tab);
		this._tabs.general.registerTab("support", SurStudioPluginTranslatorRevolutionLiteAdmin._show_buttons_on_tab);
		
		this._tabs.advanced = new SurStudioPluginTranslatorRevolutionLiteCommon.Tabs(2);

		this._tabs.advanced.registerTab("advanced_general");
		this._tabs.advanced.registerTab("advanced_import_export");

		this._tabs.translations = new SurStudioPluginTranslatorRevolutionLiteCommon.Tabs(3);

		this._tabs.translations.registerTab("translations_general");
		this._tabs.translations.registerTab("translations_import");
		this._tabs.translations.registerTab("translations_export");

	},

	_show_buttons: function(_state) {
		
		if (_state) {
			this._buttons.save.show();
			this._buttons.reset.show();
		}
		else {
			this._buttons.save.hide();
			this._buttons.reset.hide();
		}
		
	},
	
	_show_buttons_on_tab: function(_param) {
		
		SurStudioPluginTranslatorRevolutionLiteAdmin._show_buttons(_param != "translations" && _param != "support");
		
	},

	_initialize_elements: function() {
	
		this._form = SurStudioPluginTranslatorRevolutionLiteCommon.$("surstudio_admin");
		this._action = SurStudioPluginTranslatorRevolutionLiteCommon.$("surstudio_plugin_translator_revolution_lite_admin_action");

		this._fields.general.languages = jQuery("#section_surstudio_languages input");
		this._fields.general.translation_service = jQuery("#surstudio_translation_service");
		this._fields.general.cookie = jQuery("#surstudio_cookie input");
		this._fields.general.names = jQuery("#surstudio_names input");
		this._fields.general.complete = jQuery("#surstudio_complete input");
		this._fields.advanced.location_widget = jQuery("#surstudio_location_widget input");
		this._fields.advanced.jquery_auto_load = jQuery("#surstudio_jquery_auto_load input");
		this._fields.advanced.local_storage = jQuery("#surstudio_local_storage input");

		this._fields.translations.resource = jQuery("#surstudio_translations_resource");
		this._fields.translations.resource_loading = jQuery("#surstudio_translations_resource_loading");
		
		this._fields.translations.import_csv = jQuery("#surstudio_translations_import_csv");
		this._fields.translations.import_csv_upload = jQuery("#surstudio_translations_import_csv_upload");
		this._fields.translations.import_csv_upload_fk = jQuery("#surstudio_translations_import_csv_fk");
		
		this._fields.translations.languages = jQuery("#surstudio_translations_languages");
		this._fields.translations.languages_loading = jQuery("#surstudio_translations_languages_loading");
		this._fields.translations.languages_container = jQuery("#surstudio_translations_languages_container");
		this._fields.translations.language_resource = jQuery("#surstudio_translations_language_resource");
		
		this._fields.translations.cached_translations = jQuery("#surstudio_translations_cached_translations");
		this._fields.translations.cached_translations_buttons = jQuery("#surstudio_translations_cached_translations_buttons");
		this._fields.translations.cached_translations_loading = jQuery("#surstudio_translations_cached_translations_loading");
		this._fields.translations.cached_translations_saved = jQuery(".surstudio_plugin_translator_revolution_lite_cached_translations_saved");
		
		this._fields.translations.parents = jQuery("#section_surstudio_translations_export input[name^=surstudio_translations_export_foo]");

		this._buttons.save = jQuery(".button-primary").not(".save-translations, .export-translations");
		this._buttons.reset = jQuery(".reset-settings").not(".surstudio_plugin_translator_revolution_lite_file_upload_container_div input");

	},
	
	_initialize_events: function() {
		
		jQuery('.surstudio_plugin_translator_revolution_lite_faq ol li span').expander({
			slicePoint: 50,
			expandEffect: 'fadeIn',
			expandSpeed: 0,
			collapseEffect: 'fadeOut',
			collapseSpeed: 0,
			summaryClass: 'surstudio_plugin_translator_revolution_lite_faq_summary',
			detailClass: 'surstudio_plugin_translator_revolution_lite_faq_details',
			moreClass: 'surstudio_plugin_translator_revolution_lite_faq_read_more',
			lessClass: 'surstudio_plugin_translator_revolution_lite_faq_read_less',
			userCollapseText: '[^]'
		});
		
		this._fields.translations.import_csv.hover(function() {
			
			SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.import_csv_upload.addClass("surstudio_plugin_translator_revolution_lite_button_hover");
			
		}, function() {
			
			SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.import_csv_upload.removeClass("surstudio_plugin_translator_revolution_lite_button_hover");
			
		});
		
		this._fields.translations.import_csv.bind("change", function() {
			
			SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.import_csv_upload_fk.val(SurStudioPluginTranslatorRevolutionLiteAdmin._get_file_name(SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.import_csv.val()));
			
		});
		
		this._fields.translations.parents.bind("click", function() {
			
			SurStudioPluginTranslatorRevolutionLiteAdmin._handle_translations_parent_click(jQuery(this));
			
		});
		
	},
	
	_handle_translations_parent_click: function(_element) {

		var parent = _element.parents(".surstudio_plugin_translator_revolution_lite_transexport_item");
		var children = parent.find(".surstudio_plugin_translator_revolution_lite_transexport_parent .surstudio_plugin_translator_revolution_lite_checkbox");
		
		children.each(function() { 
			this.checked = _element.get(0).checked;
		});
		
	},
	
	_handle_translations_parent_click_should_change: function(_element, _elements) {

		var flag;
		
		for (var i=0; i<_elements.length; i++) {
			
			if (i == 0) {
				flag = _elements.get(i).checked;
				continue;
			}
			
			if (_elements.get(i).checked != flag)
				return false;

		}
		
		return true;
		
	},
	
	_initialize_dependences: function() {	

		SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.add(this._fields.general.translation_service, "change", function() {

			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_microsoft_client_id", this.value == "ma");
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_microsoft_client_secret", this.value == "ma");
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_google_api_key", this.value == "gt");
			
		});	
	
		SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.add(this._fields.general.cookie, "click", function() {

			var heading = SurStudioPluginTranslatorRevolutionLiteCommon.getHeadingObject(this, SurStudioPluginTranslatorRevolutionLiteAdmin._headings);

			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_cookie_persistency", this.value == "true" && heading.isShowing());
			
		});
	
		SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.add(this._fields.general.names, "click", function() {

			var heading = SurStudioPluginTranslatorRevolutionLiteCommon.getHeadingObject(this, SurStudioPluginTranslatorRevolutionLiteAdmin._headings);

			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_short_names", this.value == "true" && heading.isShowing());
			
		});

		SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.add(this._fields.general.complete, "click", function() {
			
			var heading = SurStudioPluginTranslatorRevolutionLiteCommon.getHeadingObject(this, SurStudioPluginTranslatorRevolutionLiteAdmin._headings);
			
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_auto_select", this.value == "true" && heading.isShowing());
			
		});

		SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.add(this._fields.advanced.location_widget, "click", function() {
			
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_location_custom", this.value == "false" && this.value != "top");
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_custom_location_insert_mode", this.value == "false" && this.value != "top");
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_bar_container_id", this.value != "false" && this.value != "top");
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_widget_class", this.value != "false" && this.value != "top");
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_custom_parent", this.value != "top");
			
		});
		
		SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.add(this._fields.advanced.jquery_auto_load, "click", function() {
			
			var heading = SurStudioPluginTranslatorRevolutionLiteCommon.getHeadingObject(this, SurStudioPluginTranslatorRevolutionLiteAdmin._headings);
			
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_jquery_url", this.value == "true" && heading.isShowing());
			
		});

		SurStudioPluginTranslatorRevolutionLiteCommon.Dependencies.add(this._fields.advanced.local_storage, "click", function() {
			
			var heading = SurStudioPluginTranslatorRevolutionLiteCommon.getHeadingObject(this, SurStudioPluginTranslatorRevolutionLiteAdmin._headings);
			
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_local_storage_expires", this.value == "true" && heading.isShowing());
			SurStudioPluginTranslatorRevolutionLiteAdmin.showSection("section_surstudio_clear_local_storage", this.value == "true" && heading.isShowing());
			
		});

	},
	
	_initialize_headings: function() {
		
		var headings = jQuery(".surstudio_plugin_translator_revolution_lite_heading");
		for (var i=0; i<headings.length; i++)
			SurStudioPluginTranslatorRevolutionLiteAdmin._headings[headings[i].id] = new SurStudioPluginTranslatorRevolutionLiteCommon.Heading(headings[i]);

	},
		
	_initialize_languages: function() {

		var sorter = jQuery("#section_surstudio_languages_order ul.surstudio_plugin_translator_revolution_lite_language_order_group");
	
		sorter.dragsort({
			dragBetween: true,
			placeHolderTemplate: '<li class="surstudio_plugin_translator_revolution_lite_language_order_item surstudio_plugin_translator_revolution_lite_language_place_holder"></li>',
			dragEnd: this._languages_order_update
		});
	
		this._fields.general.languages.click(function() {
			
			SurStudioPluginTranslatorRevolutionLiteAdmin._languages_update(this);
			
		});
		
	},
	
	resetSearchTranslation: function(_reset) {
		
		var fields = this._fields.translations.cached_translations.find("textarea[name^=surstudio_translations_cached_]");
		var row;
				
		if (_reset)
			jQuery("#surstudio_translations_search").val("");
				
		for (var i=0; i<fields.length; i++) {
			row = fields.eq(i).parents("tr");
			row.removeClass("surstudio_plugin_translator_revolution_lite_cached_translations_found");
			if (_reset)
				row.removeClass("surstudio_plugin_translator_revolution_lite_no_display");
		}					
		
	},
	
	preSearchTranslation: function(_e) {
	
		if (_e && _e.keyCode == 13) {
			this.searchTranslation();
			return false;
		}
		
		return true;
		
	},
	
	searchTranslation: function() {
		
		var value = jQuery("#surstudio_translations_search").val();
		
		var fields = this._fields.translations.cached_translations.find("textarea[name^=surstudio_translations_cached_]");
		var pattern = new RegExp(value, "gi");
		var field;
			
		this.resetSearchTranslation(false);
			
		for (var i=0; i<fields.length; i++) {
			field = fields.eq(i);
			this._show_cached_translation(field, field.val().match(pattern));
		}
		
	},
	
	_show_cached_translation: function(_element, _status) {
		
		var row = _element.parents("tr");
		
		if (row.hasClass("surstudio_plugin_translator_revolution_lite_cached_translations_found"))
			return;
		
		if (_status) {
			row.addClass("surstudio_plugin_translator_revolution_lite_cached_translations_found");
			row.removeClass("surstudio_plugin_translator_revolution_lite_no_display");
		}
		else
			row.addClass("surstudio_plugin_translator_revolution_lite_no_display");
		
	},
	
	_on_file_upload_change: function() {
		
		this._fields.translations.import_csv_upload_fk.val(this._get_file_name(this._fields.translations.import_csv.val()));
		
	},
	
	_get_file_name: function(_path) {

		try {
			return _path.match(/[^/\\]*$/)[0];
		}
		catch(e) {
			return _path;
		}

	},
	
	_show_languages_loading: function(_state) {
		
		if (_state) 
			this._fields.translations.languages_loading.addClass("surstudio_plugin_translator_revolution_lite_loading");
		else
			this._fields.translations.languages_loading.removeClass("surstudio_plugin_translator_revolution_lite_loading");
		
	},
	
	_show_resource_loading: function(_state) {
		
		if (_state) 
			this._fields.translations.resource_loading.addClass("surstudio_plugin_translator_revolution_lite_loading");
		else
			this._fields.translations.resource_loading.removeClass("surstudio_plugin_translator_revolution_lite_loading");
		
	},

	_show_cached_translations_loading: function(_state) {
		
		if (_state) 
			this._fields.translations.cached_translations_loading.addClass("surstudio_plugin_translator_revolution_lite_loading");
		else
			this._fields.translations.cached_translations_loading.removeClass("surstudio_plugin_translator_revolution_lite_loading");
		
	},

	_show_languages: function(_state) {

		if (_state)
			this._fields.translations.languages_container.removeClass("surstudio_plugin_translator_revolution_lite_no_display");			
		else
			this._fields.translations.languages_container.addClass("surstudio_plugin_translator_revolution_lite_no_display");
		
	},
	
	_show_cached_translations: function(_state) {
	
		if (_state) {
			this._fields.translations.cached_translations_buttons.removeClass("surstudio_plugin_translator_revolution_lite_no_display");
			this._fields.translations.cached_translations.removeClass("surstudio_plugin_translator_revolution_lite_no_display");			
		}
		else {
			this._fields.translations.cached_translations_buttons.addClass("surstudio_plugin_translator_revolution_lite_no_display");
			this._fields.translations.cached_translations.addClass("surstudio_plugin_translator_revolution_lite_no_display");
		}
		
	},
	
	_set_cached_translations_content: function(_data) {
		
		SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.cached_translations.html(_data);
		
	},
	
	resetCachedTranslations: function() {
		
		if (this._xhr.cached_translations)
			this._xhr.cached_translations.abort();

		this._show_cached_translations_loading(false);
		this._show_cached_translations(false);
		SurStudioPluginTranslatorRevolutionLiteAdmin._set_cached_translations_content("");
		
	},

	resetLanguage: function() {
		
		if (this._xhr.languages)
			this._xhr.languages.abort();
		
		this._show_languages_loading(false);
		this._fields.translations.languages.get(0).selectedIndex = 0;
		
		this.resetCachedTranslations();
		
	},
	
	selectLanguage: function() {
		
		var language = this._fields.translations.languages.val();
		
		if (language == "")
			return;
		
		this._show_languages_loading(true);

		this._show_cached_translations(false);
		this.resetCachedTranslations();
		
		this._xhr.languages = jQuery.ajax({
			url: this._get_ajax_url(),
			type: "post",
			data: {
				action: "surstudio_plugin_translator_revolution_lite_get_cached_translations",
				surstudio_translations_languages: language
			},
			success: SurStudioPluginTranslatorRevolutionLiteAdmin.selectLanguageSuccess
		});
		
	},
	
	selectLanguageSuccess: function(_data) {

		SurStudioPluginTranslatorRevolutionLiteAdmin._show_languages_loading(false);
		SurStudioPluginTranslatorRevolutionLiteAdmin._set_cached_translations_content(_data);
		SurStudioPluginTranslatorRevolutionLiteAdmin._show_cached_translations(true);
		SurStudioPluginTranslatorRevolutionLiteAdmin._update_cached_translations_crc();
		
	},
	
	resetResource: function() {
		
		this._xhr.resource.abort();
		this._show_resource_loading(false);
		this._fields.translations.resource.get(0).selectedIndex = 0;
		
		this.resetLanguage();
		this._show_languages(false);
		
	},
	
	selectResource: function() {
		
		var resource = this._fields.translations.resource.val();
		
		if (resource == "")
			return;
		
		this._show_resource_loading(true);

		this._show_languages(false);
		this._show_cached_translations(false);
		this.resetLanguage();
		this.resetCachedTranslations();
		
		this._xhr.resource = jQuery.ajax({
			url: this._get_ajax_url(),
			type: "post",
			data: {
				action: "surstudio_plugin_translator_revolution_lite_get_languages_per_resource",
				surstudio_translations_resource: resource
			},
			success: SurStudioPluginTranslatorRevolutionLiteAdmin.selectResourceSuccess
		});
		
	},
	
	selectResourceSuccess: function(_data) {
		
		var data = jQuery.parseJSON(_data);
		SurStudioPluginTranslatorRevolutionLiteAdmin._show_resource_loading(false);
		SurStudioPluginTranslatorRevolutionLiteAdmin.setLanguageResourceLabel(data.resource);
		SurStudioPluginTranslatorRevolutionLiteAdmin.setLanguageLite(data.languages);
		SurStudioPluginTranslatorRevolutionLiteAdmin._show_languages(true);
		
	},
	
	setLanguageLite: function(_data) {
	
		var select = this._fields.translations.languages.get(0);
		select.options.length = 0;
				
		var data = [{ 
			text: '',
			value: '' 
		}];

		for (var i in _data)
			data.push({
				text: i,
				value: _data[i].file
			});

		for(var i=0; i < data.length; i++)
			select.options.add(new Option(data[i].text, data[i].value));
		
	},
	
	setCachedTranslationsLabel: function(_data) {
		
		this._fields.translations.cached_translations.html(_data);
		
	},
	
	setLanguageResourceLabel: function(_data) {
	
		this._fields.translations.language_resource.html(_data);
		
	},
	
	_languages_update: function(_checkbox) {

		if (_checkbox.checked) {
			
			var container = jQuery(_checkbox).parents(".surstudio_plugin_translator_revolution_lite_language_item");
			var item = container.find(".surstudio_plugin_translator_revolution_lite_language_order_item").clone(false);
			item.attr("id", "surstudio_plugin_translator_revolution_lite_language_order_item_" + _checkbox.value);
		
			var sorter = jQuery("#section_surstudio_languages_order ul.surstudio_plugin_translator_revolution_lite_language_order_group");
			sorter.append(item);
			
		}
		else
			jQuery("#surstudio_plugin_translator_revolution_lite_language_order_item_" + _checkbox.value).remove();
		
		this._languages_order_update();
		
	},
	
	_languages_order_update: function() {
		
		var result = [];
		var target = jQuery("#surstudio_languages_order");
		var items = jQuery("#section_surstudio_languages_order ul.surstudio_plugin_translator_revolution_lite_language_order_group input");
		for (var i=0; i<items.length; i++)
			result.push(items[i].value);
		target.val(result.join(","));
		
	},
	
	_initialize_tooltips: function() {
		
		SurStudioPluginTranslatorRevolutionLiteCommon.initializeTooltip(".surstudio_plugin_translator_revolution_lite_tooltip");
		
	},
	
	showSection: function(_section_id, _state, _now) {
		
		if (_now === true) {
			if (_state)
				jQuery("#" + _section_id).show();
			else
				jQuery("#" + _section_id).hide();
		}
		else {
			if (_state)
				jQuery("#" + _section_id).slideDown("fast");
			else
				jQuery("#" + _section_id).slideUp("fast");
		}
		
	},
	
	submitSettings: function() {
		
		this._form.submit();
		
	},
	
	resetSettings: function(_message) {
	
		if (confirm(_message)) {
			this._action.value = "surstudio_plugin_translator_revolution_lite_reset_settings";
			this._form.submit();
			return true;
		} 

		return false;
		
	},
	
	saveCachedTranslations: function() {
	
		var cached_translations = this._get_new_translations();
		
		cached_translations["action"] = "surstudio_plugin_translator_revolution_lite_save_cached_translations";
		cached_translations["surstudio_translations_languages"] = this._fields.translations.languages.val();
		
		this._show_cached_translations_loading(true);
		
		this._xhr.cached_translations = jQuery.ajax({
			url: this._get_ajax_url(),
			type: "post",
			data: cached_translations,
			success: SurStudioPluginTranslatorRevolutionLiteAdmin.saveCachedTranslationsSuccess
		});
		
	},
	
	saveCachedTranslationsSuccess: function(_data) {
		
		SurStudioPluginTranslatorRevolutionLiteAdmin._show_cached_translations_message();
		SurStudioPluginTranslatorRevolutionLiteAdmin._show_cached_translations_loading(false);
		SurStudioPluginTranslatorRevolutionLiteAdmin._update_cached_translations_crc();
		SurStudioPluginTranslatorRevolutionLiteAdmin._remove_cached_translations();
		
	},
	
	_show_cached_translations_message: function() {
		
		SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.cached_translations_saved.removeClass("surstudio_plugin_translator_revolution_lite_no_display");
		
		setTimeout(function() {
			SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.cached_translations_saved.animate({
				opacity: 0,
				height: 0
			}, "fast", function() {
				SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.cached_translations_saved.addClass("surstudio_plugin_translator_revolution_lite_no_display");
				SurStudioPluginTranslatorRevolutionLiteAdmin._fields.translations.cached_translations_saved.css({
					opacity: 1,
					height: "auto"					
				})
			})
		}, 1000);
		
	},
	
	_update_cached_translations_crc: function() {
		
		var hashs = this._get_hashs();
		
		for (var i=0; i<hashs.length; i++)
			jQuery("#surstudio_translations_cached_" + hashs[i] + "_crc").val(jQuery.md5(jQuery("#surstudio_translations_cached_" + hashs[i] + "_translation").val()));
		
	},

	_remove_cached_translations: function() {
		
		var hashs = this._get_hashs();
		var field;
		
		for (var i=0; i<hashs.length; i++) {
			field = jQuery("#surstudio_translations_cached_" + hashs[i] + "_translation");
			if (field.val() == "")
				field.parents("tr").remove();
		}
		
	},
	
	_get_new_translations: function() {
		
		var result = {};
		var hashs = this._get_hashs();
		
		for (var i=0; i<hashs.length; i++)
			if (this._is_translation_updated(hashs[i])) {
				if (!("surstudio_translations" in result))
					result["surstudio_translations"] = [];
				result["surstudio_translations"].push([hashs[i], jQuery("#surstudio_translations_cached_" + hashs[i] + "_translation").val()]);
			}
		
		return result;
		
	},
	
	_is_translation_updated: function(_hash) {
		
		var crc_field = jQuery("#surstudio_translations_cached_" + _hash + "_crc");
		var translation_field = jQuery("#surstudio_translations_cached_" + _hash + "_translation");
		
		return crc_field.val() != jQuery.md5(translation_field.val());
		
	},
	
	_get_hashs: function() {
		
		var result = [];
		var fields = this._fields.translations.cached_translations.find("input[type=hidden]");
		
		for (var i=0; i<fields.length; i++)
			result.push(this._get_hash(fields.eq(i)));
		
		return result;
		
	},
	
	_get_hash: function(_element) {
		
		var id = _element.attr("id");
		var result = id.match(/_(\w{64})_/);
		
		if (!result)
			return false;
			
		return result[1];
		
	},
	
	hideMessage: function(_selector, _delay) {
		
		setTimeout(function() {
			jQuery(_selector).animate({
				opacity: 'toggle',
				height: 'toggle'
			}, "fast")
		}, _delay);
		
	}
	
};

(function($){

    var rotateLeft = function(lValue, iShiftBits) {
        return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
    };

    var addUnsigned = function(lX, lY) {
        var lX4, lY4, lX8, lY8, lResult;
        lX8 = (lX & 0x80000000);
        lY8 = (lY & 0x80000000);
        lX4 = (lX & 0x40000000);
        lY4 = (lY & 0x40000000);
        lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
        if (lX4 & lY4) return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
        if (lX4 | lY4) {
            if (lResult & 0x40000000) return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
            else return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
        } else {
            return (lResult ^ lX8 ^ lY8);
        }
    };

    var F = function(x, y, z) {
        return (x & y) | ((~ x) & z);
    };

    var G = function(x, y, z) {
        return (x & z) | (y & (~ z));
    };

    var H = function(x, y, z) {
        return (x ^ y ^ z);
    };

    var I = function(x, y, z) {
        return (y ^ (x | (~ z)));
    };

    var FF = function(a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(F(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
    };

    var GG = function(a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(G(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
    };

    var HH = function(a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(H(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
    };

    var II = function(a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(I(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
    };

    var convertToWordArray = function(string) {
        var lWordCount;
        var lMessageLength = string.length;
        var lNumberOfWordsTempOne = lMessageLength + 8;
        var lNumberOfWordsTempTwo = (lNumberOfWordsTempOne - (lNumberOfWordsTempOne % 64)) / 64;
        var lNumberOfWords = (lNumberOfWordsTempTwo + 1) * 16;
        var lWordArray = Array(lNumberOfWords - 1);
        var lBytePosition = 0;
        var lByteCount = 0;
        while (lByteCount < lMessageLength) {
            lWordCount = (lByteCount - (lByteCount % 4)) / 4;
            lBytePosition = (lByteCount % 4) * 8;
            lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition));
            lByteCount++;
        }
        lWordCount = (lByteCount - (lByteCount % 4)) / 4;
        lBytePosition = (lByteCount % 4) * 8;
        lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
        lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
        lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
        return lWordArray;
    };

    var wordToHex = function(lValue) {
        var WordToHexValue = "", WordToHexValueTemp = "", lByte, lCount;
        for (lCount = 0; lCount <= 3; lCount++) {
            lByte = (lValue >>> (lCount * 8)) & 255;
            WordToHexValueTemp = "0" + lByte.toString(16);
            WordToHexValue = WordToHexValue + WordToHexValueTemp.substr(WordToHexValueTemp.length - 2, 2);
        }
        return WordToHexValue;
    };

    var uTF8Encode = function(string) {
        string = string.replace(/\x0d\x0a/g, "\x0a");
        var output = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                output += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                output += String.fromCharCode((c >> 6) | 192);
                output += String.fromCharCode((c & 63) | 128);
            } else {
                output += String.fromCharCode((c >> 12) | 224);
                output += String.fromCharCode(((c >> 6) & 63) | 128);
                output += String.fromCharCode((c & 63) | 128);
            }
        }
        return output;
    };

    $.extend({
        md5: function(string) {
                 var x = Array();
                 var k, AA, BB, CC, DD, a, b, c, d;
                 var S11=7, S12=12, S13=17, S14=22;
                 var S21=5, S22=9 , S23=14, S24=20;
                 var S31=4, S32=11, S33=16, S34=23;
                 var S41=6, S42=10, S43=15, S44=21;
                 string = uTF8Encode(string);
                 x = convertToWordArray(string);
                 a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476;
                 for (k = 0; k < x.length; k += 16) {
                     AA = a; BB = b; CC = c; DD = d;
                     a = FF(a, b, c, d, x[k+0],  S11, 0xD76AA478);
                     d = FF(d, a, b, c, x[k+1],  S12, 0xE8C7B756);
                     c = FF(c, d, a, b, x[k+2],  S13, 0x242070DB);
                     b = FF(b, c, d, a, x[k+3],  S14, 0xC1BDCEEE);
                     a = FF(a, b, c, d, x[k+4],  S11, 0xF57C0FAF);
                     d = FF(d, a, b, c, x[k+5],  S12, 0x4787C62A);
                     c = FF(c, d, a, b, x[k+6],  S13, 0xA8304613);
                     b = FF(b, c, d, a, x[k+7],  S14, 0xFD469501);
                     a = FF(a, b, c, d, x[k+8],  S11, 0x698098D8);
                     d = FF(d, a, b, c, x[k+9],  S12, 0x8B44F7AF);
                     c = FF(c, d, a, b, x[k+10], S13, 0xFFFF5BB1);
                     b = FF(b, c, d, a, x[k+11], S14, 0x895CD7BE);
                     a = FF(a, b, c, d, x[k+12], S11, 0x6B901122);
                     d = FF(d, a, b, c, x[k+13], S12, 0xFD987193);
                     c = FF(c, d, a, b, x[k+14], S13, 0xA679438E);
                     b = FF(b, c, d, a, x[k+15], S14, 0x49B40821);
                     a = GG(a, b, c, d, x[k+1],  S21, 0xF61E2562);
                     d = GG(d, a, b, c, x[k+6],  S22, 0xC040B340);
                     c = GG(c, d, a, b, x[k+11], S23, 0x265E5A51);
                     b = GG(b, c, d, a, x[k+0],  S24, 0xE9B6C7AA);
                     a = GG(a, b, c, d, x[k+5],  S21, 0xD62F105D);
                     d = GG(d, a, b, c, x[k+10], S22, 0x2441453);
                     c = GG(c, d, a, b, x[k+15], S23, 0xD8A1E681);
                     b = GG(b, c, d, a, x[k+4],  S24, 0xE7D3FBC8);
                     a = GG(a, b, c, d, x[k+9],  S21, 0x21E1CDE6);
                     d = GG(d, a, b, c, x[k+14], S22, 0xC33707D6);
                     c = GG(c, d, a, b, x[k+3],  S23, 0xF4D50D87);
                     b = GG(b, c, d, a, x[k+8],  S24, 0x455A14ED);
                     a = GG(a, b, c, d, x[k+13], S21, 0xA9E3E905);
                     d = GG(d, a, b, c, x[k+2],  S22, 0xFCEFA3F8);
                     c = GG(c, d, a, b, x[k+7],  S23, 0x676F02D9);
                     b = GG(b, c, d, a, x[k+12], S24, 0x8D2A4C8A);
                     a = HH(a, b, c, d, x[k+5],  S31, 0xFFFA3942);
                     d = HH(d, a, b, c, x[k+8],  S32, 0x8771F681);
                     c = HH(c, d, a, b, x[k+11], S33, 0x6D9D6122);
                     b = HH(b, c, d, a, x[k+14], S34, 0xFDE5380C);
                     a = HH(a, b, c, d, x[k+1],  S31, 0xA4BEEA44);
                     d = HH(d, a, b, c, x[k+4],  S32, 0x4BDECFA9);
                     c = HH(c, d, a, b, x[k+7],  S33, 0xF6BB4B60);
                     b = HH(b, c, d, a, x[k+10], S34, 0xBEBFBC70);
                     a = HH(a, b, c, d, x[k+13], S31, 0x289B7EC6);
                     d = HH(d, a, b, c, x[k+0],  S32, 0xEAA127FA);
                     c = HH(c, d, a, b, x[k+3],  S33, 0xD4EF3085);
                     b = HH(b, c, d, a, x[k+6],  S34, 0x4881D05);
                     a = HH(a, b, c, d, x[k+9],  S31, 0xD9D4D039);
                     d = HH(d, a, b, c, x[k+12], S32, 0xE6DB99E5);
                     c = HH(c, d, a, b, x[k+15], S33, 0x1FA27CF8);
                     b = HH(b, c, d, a, x[k+2],  S34, 0xC4AC5665);
                     a = II(a, b, c, d, x[k+0],  S41, 0xF4292244);
                     d = II(d, a, b, c, x[k+7],  S42, 0x432AFF97);
                     c = II(c, d, a, b, x[k+14], S43, 0xAB9423A7);
                     b = II(b, c, d, a, x[k+5],  S44, 0xFC93A039);
                     a = II(a, b, c, d, x[k+12], S41, 0x655B59C3);
                     d = II(d, a, b, c, x[k+3],  S42, 0x8F0CCC92);
                     c = II(c, d, a, b, x[k+10], S43, 0xFFEFF47D);
                     b = II(b, c, d, a, x[k+1],  S44, 0x85845DD1);
                     a = II(a, b, c, d, x[k+8],  S41, 0x6FA87E4F);
                     d = II(d, a, b, c, x[k+15], S42, 0xFE2CE6E0);
                     c = II(c, d, a, b, x[k+6],  S43, 0xA3014314);
                     b = II(b, c, d, a, x[k+13], S44, 0x4E0811A1);
                     a = II(a, b, c, d, x[k+4],  S41, 0xF7537E82);
                     d = II(d, a, b, c, x[k+11], S42, 0xBD3AF235);
                     c = II(c, d, a, b, x[k+2],  S43, 0x2AD7D2BB);
                     b = II(b, c, d, a, x[k+9],  S44, 0xEB86D391);
                     a = addUnsigned(a, AA);
                     b = addUnsigned(b, BB);
                     c = addUnsigned(c, CC);
                     d = addUnsigned(d, DD);
                 }
                 var tempValue = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);
                 return tempValue.toLowerCase();
             }
    });
})(jQuery);